SELECT DISTINCT
    COALESCE(bg.benutzer_id, br.benutzer_id) AS benutzer_id,
    g.id AS gruppe_id,
    g.gruppenname,
    g.erstellt_am,
    g.geaendert_am,
    CASE WHEN br.benutzer_id IS NOT null THEN r.rollenname END
        AS rollenname
FROM gruppen AS g
LEFT JOIN
    benutzer_gruppen AS bg
    ON
        g.id = bg.gruppe_id
        AND bg.benutzer_id = ANY($1) 
LEFT JOIN rollen_gruppen AS rg ON g.id = rg.gruppe_id
LEFT JOIN
    benutzer_rollen AS br
    ON
        rg.rolle_id = br.rolle_id
        AND br.benutzer_id = ANY($1) 
LEFT JOIN rollen AS r ON rg.rolle_id = r.id
WHERE
    bg.benutzer_id = ANY($1) 
    OR br.benutzer_id = ANY($1); 
